#include <minigui.ch>
#include <hfcl.ch>

Function TranPrint()
	PRIVATE mTranRec := 0, aRows := {}, aSum
	
	aSum := {{.f.,""},{.f.,""},{.t.,"999,999,999.99"}}
	

   DEFINE WINDOW frmTranPrint            ;
      AT 0,0               ;
      WIDTH 790            ;
      HEIGHT 590            ;
      TITLE 'Expense Report'   ;
      MODAL ;
      ON INIT {|| mTranRec := iif(tran->(Eof()), 0, tran->(recno()))}  ;
      ON RELEASE {|| IIF(mTranRec <> 0, tran->(DBgoto(mTranrec)), NIL)}
      
      @ 10, 10 label lblFromdt value "From:"
      @ 10, 50 datepicker dpkFromdt value bom(date())
      
      @ 10, 200 label lblTodt value "To:"
      @ 10, 230 datepicker dpkTodt value eom(date())
     
      @ 10, 670 button cmdRun caption "&Run" ;
      	action CreateGrid()
      
      
		@ 40,10 GRID Grid_1 ;
			WIDTH 650 ;
			HEIGHT 470 ;
			HEADERS {'Date','Head','Amount'} ;
			WIDTHS {100,400,100} ;
			JUSTIFY {0,0,1};
			ITEMS aRows ;
			VALUE 1 
			
      @ 480, 670 button cmdPrint caption "&Print" ;
      	action DoPrint()
      
      @ 520, 450 label lblTotal value "Total:"
      @ 520, 500 textbox txtTotamt ;
      	readonly value 0.00 numeric inputmask "9999999.99"
      
   END WINDOW
   frmTranPrint.center
   frmTranPrint.activate
	return NIL
	

static function CreateGrid()
	local mFromdt := frmTranPrint.dpkFromdt.value, mTodt := frmTranPrint.dpkTodt.value, ;
		mTotamt := 0.00
	frmTranPrint.grid_1.deleteallitems()
	aRows := {}
	dbeval({|| aadd(aRows, {dtoc(tran->trandt), exp->expnm, str(tran->amt, 12, 2)}), mTotamt += tran->amt}, ;
		{|| tran->trandt >= mFromdt .and. tran->trandt <= mTodt})
	aEval(aRows, {|x| frmTranPrint.grid_1.additem(x)})
	frmTranPrint.txtTotamt.value := mTotamt
	return nil
	
	
static function DoPrint()
	local mFromdt := frmTranPrint.dpkFromdt.value, mTodt := frmTranPrint.dpkTodt.value, ;
		strHead
	
	strHead := "("+dtoc(mFromdt)+" to "+dtoc(mTodt)+")"
	PRINT GRID grid_1 OF frmTranPrint FONT "Arial" SIZE 12 ORIENTATION "P" ;
		HEADERS {"Expense Report", strHead} COLUMNSUM aSum

	return nil	